import java.util.concurrent.ThreadLocalRandom;

class Exo3 {

    static final int nbCells = 10_000_000;
    static final int nbCoresDefault = 2;
    static int N, seqOutput, par2Output, parNOutput;

    public static void main(String []argv){

        N = getNbThreads(argv);
        Character []array = randomCharArray();
        Character c = randomChar();
        float seqTime = Chrono.run( () -> {
            seqOutput = nbOccurs(array, c);
        }); 
        System.out.printf("Résultat avec nbOccurs : %d\n", seqOutput);
        System.out.printf("Temps avec nbOccurs: %.2f\n", seqTime);
        float par2Time = Chrono.run( () -> {
            par2Output = nbOccursParallel2(array, c);
        }); 
        System.out.printf("Résultat avec nbOccursParallel2 : %d\n", par2Output);
        System.out.printf("Speedup avec nbOccursParallel2: %.2f\n", seqTime / par2Time);
        float parNTime = Chrono.run( () -> {
            parNOutput  = nbOccursParallelN(array, c);
        }); 
        System.out.printf("Résultat avec nbOccursParallelN : %d\n", parNOutput);
        System.out.printf("Speedup avec nbOccursParallelN (N=%d): %.2f\n", N, seqTime / parNTime);
    }


    static int getNbThreads(String []argv){
        try { return Integer.parseInt(argv[0]); }
        catch (Exception e) { return Runtime.getRuntime().availableProcessors();}
    }

    static int nbOccurs(Character []array, Character c){
        int res = 0;
        for(Character c2 : array) {
            if (c.equals(c2)) res++;
        }
        return res; 
    }

    static int nbOccursParallel2(Character []array, Character c){
        // A MODIFIER!
        return nbOccurs(array, c); 
    }

    static int nbOccursParallelN(Character []array, Character c){
        // A MODIFIER!
        return nbOccurs(array, c); 
    }

    static Character randomChar(){
        ThreadLocalRandom rand = ThreadLocalRandom.current();
        return (char) rand.nextInt(256);
    }

    static Character []randomCharArray(){
        Character []res = new Character[nbCells];
        for(int i=0; i<nbCells; i++) res[i] = randomChar();
        return res;
    }
}